// ListBoxODOrder.cpp: implementation of the CListBoxODOrder class.
// Copyright (c) 2015 by David Wincelberg
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ListBoxODOrder.h"

#include "ListBoxODData.h"
#include "StringOrder.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// Note:	These parameters relate to the Strategy and Flyweight patterns.
CListBoxODOrder::CListBoxODOrder (CStringOrder* pStringOrder /* = nullptr */,
								  bool bHandleDelete /* = true */) :
								  CListBoxOrder (pStringOrder, bHandleDelete)
{

}


CListBoxODOrder::~CListBoxODOrder()
{

}

//////////////////////////////////////////////////////////////////////
// Operations
//////////////////////////////////////////////////////////////////////

// Action:	Compares two strings using the supplied string order.
// Note:	This virtual function may be replaced for custom ordering.
//			The framework expects the result to be -1, 0 or 1.
int CListBoxODOrder::Compare (CListBoxODData* pData1, CListBoxODData* pData2)
{
	if (!ValidStringOrder())
		return 0;

	CString strItem1, strItem2;

	if (pData1 != nullptr)
		pData1->GetString (strItem1);

	if (pData2 != nullptr)
		pData2->GetString (strItem2);

	return GetStringOrder()->CompareStrings (strItem1, strItem2);
}	// Compare
